/*
 Created by : Firdaus
 Last Update: 29 Sept 2016
 Description: Module for contact Lucky Draw
 */
angular.module('luckyDraw.controller',[]) // map.controller need to be register @ app.js
    .controller('luckyDraw', function($scope, $state,PostService,$ionicLoading,$timeout,$stateParams) {
		function getTimeRemaining(endtime) {
			var t = Date.parse(endtime) - Date.parse(new Date());
			var seconds = Math.floor((t / 1000) % 60);
			var minutes = Math.floor((t / 1000 / 60) % 60);
			var hours = Math.floor((t / (1000 * 60 * 60)) % 24);
			var days = Math.floor(t / (1000 * 60 * 60 * 24));
			return {
				'total': t,
				'days': days,
				'hours': hours,
				'minutes': minutes,
				'seconds': seconds
			};
		}

		function initializeClock(id, endtime) {
			var clock = document.getElementById(id);
			var daysSpan = clock.querySelector('.days');
			var hoursSpan = clock.querySelector('.hours');
			var minutesSpan = clock.querySelector('.minutes');
			var secondsSpan = clock.querySelector('.seconds');

			function updateClock() {
				var t = getTimeRemaining(endtime);

				daysSpan.innerHTML = t.days;
				hoursSpan.innerHTML = ('0' + t.hours).slice(-2);
				minutesSpan.innerHTML = ('0' + t.minutes).slice(-2);
				secondsSpan.innerHTML = ('0' + t.seconds).slice(-2);

				if (t.total <= 0) {
					clearInterval(timeinterval);
					var data3 = JSON.parse(window.localStorage.getItem('connAPI'));
					var comp_code = data3.mobile_user[0].company_code;
				    var mem_id = data3.mobile_user[0].member_id;
				    var conn_id = window.localStorage.getItem('connId');
				    var lang_id = data3.mobile_user[0].lang_id;
					PostService.getCountdown(comp_code,mem_id,conn_id,lang_id,$stateParams.menuID).then(function(data){
							var keys = [];
							for(var k in data.result[0]) keys.push(k);
							$scope.headerResults = keys;
							$scope.resultLuckyDraws = data.result;
							$scope.showResult = "resulttt";
						    $scope.showCounter = "none";
					});
				}
			}

			updateClock();
			var timeinterval = setInterval(updateClock, 1000);
		}

		// var deadline = new Date(Date.parse(new Date()) + 15 * 24 * 60 * 60 * 1000);
		$scope.$on("$ionicView.beforeEnter", function(event, data){
			var data2 = JSON.parse(window.localStorage.getItem('connAPI'));
			var comp_code = data2.mobile_user[0].company_code;
		    var mem_id = data2.mobile_user[0].member_id;
		    var conn_id = window.localStorage.getItem('connId');
		    var lang_id = data2.mobile_user[0].lang_id;
			PostService.getCountdown(comp_code,mem_id,conn_id,lang_id,$stateParams.menuID).then(function(data){
					console.log(data);
					if(data.date_countdown === ''){
						var keys = [];
						for(var k in data.result[0]) keys.push(k);
						$scope.headerResults = keys;
						$scope.resultLuckyDraws = data.result;
						$scope.showResult = "resulttt";
						$scope.showCounter = "none";
					}else{
						$scope.showCounter = "counter";
						$scope.showResult = "none";
						$timeout(function () {
							var deadline = new Date(Date.parse(new Date()) + data.date_countdown * 1000);
							// var deadline = new Date(Date.parse(new Date()) + 5 * 1000);
							initializeClock('clockdiv', deadline);
						});
					}
				});
		});
	});