/*
Created by : Firdaus
Last Update: 11 April 2016
Description: Module for Map functionality
*/
angular.module('map.controller', ['map.services']) // map.controller need to be register @ app.js

    .controller('testMapCtrl', function($cordovaDialogs,$scope, $ionicConfig,$state,mapService,$cordovaGeolocation,$stateParams,$ionicLoading,translate) {
        var posOptions = {timeout: 10000, enableHighAccuracy: false};
        var lang_id = window.localStorage.getItem('lang_default');
        cordova.plugins.diagnostic.isLocationEnabled(function(response){
            if(response){
                $cordovaGeolocation
                    .getCurrentPosition(posOptions)
                    .then(function (position) {
                        $ionicLoading.hide();
                        var lat  = position.coords.latitude;
                        var long = position.coords.longitude;
                        window.open('http://maps.google.com/maps?saddr='+lat+','+long+'&daddr='+d_lat+','+d_long+'&dirflg=d','_system','location=yes');
                        return false;
                    }, function(err) {
                        $ionicLoading.hide();
                        $cordovaDialogs.confirm(translate.multiLanguage('sorry_failed_to_get_your_current_location',lang_id),
                            translate.multiLanguage('cannot_get_current_location',lang_id), [translate.multiLanguage('cancel',lang_id),translate.multiLanguage('ok',lang_id)])
                            .then(function(buttonIndex) {
                                switch(buttonIndex) {
                                    case 0: break;//cancel
                                    case 1: break;//neutro option
                                    case 2: cordova.plugins.diagnostic.switchToLocationSettings();
                                        break;//user go to configuration
                                }
                            });
                    });
            }else{
                $ionicLoading.hide();
                $cordovaDialogs.confirm(translate.multiLanguage('your_gps_is_turn_off_this_app_needs_to_be_enabled_to_works',lang_id),
                    translate.multiLanguage('please_turn_on_gps',lang_id), [translate.multiLanguage('cancel',lang_id),translate.multiLanguage('ok',lang_id)])
                    .then(function(buttonIndex) {
                        switch(buttonIndex) {
                            case 0: break;//cancel
                            case 1: break;//neutro option
                            case 2: cordova.plugins.diagnostic.switchToLocationSettings();
                                break;//user go to configuration
                        }
                    });
            }

        });

        $scope.info_position = {
            //lat: 3.026311,
            //lng: 101.615095
            lat: $stateParams.lati,
            lng: $stateParams.longi
        };

        $scope.center_position = {
            lat: $stateParams.lati,
            lng: $stateParams.longi
        };

        $scope.openUrl = function (d_lat,d_long){
            $ionicLoading.show({
                template: 'Loading...'
            });
            //window.open(url,'_system','location=yes');
            //return false;
            //$cordovaGeolocation
            //    .getCurrentPosition(posOptions)
            //    .then(function (position) {
            //        $ionicLoading.hide();
            //        var lat  = position.coords.latitude;
            //        var long = position.coords.longitude;
            //                window.open('http://maps.google.com/maps?saddr='+lat+','+long+'&daddr='+d_lat+','+d_long+'&dirflg=d','_system','location=yes');
            //                return false;
            //    }, function(err) {
            //        document.addEventListener("deviceready",function() {
            //            cordova.dialogGPS("Your GPS is Disabled, this app needs to be enable to works.",//message
            //                "Use GPS, with wifi or 3G.",//description
            //                function(buttonIndex){//callback
            //                    switch(buttonIndex) {
            //                        case 0: break;//cancel
            //                        case 1: break;//neutro option
            //                        case 2: break;//user go to configuration
            //                    }},
            //                "Please Turn on GPS",//title
            //                ["Cancel","Later","Go"]);//buttons
            //        });
            //    });

            cordova.plugins.diagnostic.isLocationEnabled(function(response){
                if(response){
                    $cordovaGeolocation
                        .getCurrentPosition(posOptions)
                        .then(function (position) {
                            $ionicLoading.hide();
                            var lat  = position.coords.latitude;
                            var long = position.coords.longitude;
                            window.open('http://maps.google.com/maps?saddr='+lat+','+long+'&daddr='+d_lat+','+d_long+'&dirflg=d','_system','location=yes');
                            return false;
                        }, function(err) {
                            $ionicLoading.hide();
                            $cordovaDialogs.confirm(translate.multiLanguage('sorry_failed_to_get_your_current_location',lang_id),
                                translate.multiLanguage('cannot_get_current_location',lang_id), [translate.multiLanguage('cancel',lang_id),translate.multiLanguage('ok',lang_id)])
                                .then(function(buttonIndex) {
                                    switch(buttonIndex) {
                                        case 0: break;//cancel
                                        case 1: break;//neutro option
                                        case 2: cordova.plugins.diagnostic.switchToLocationSettings();
                                            break;//user go to configuration
                                    }
                                });
                        });
                }else{
                    $ionicLoading.hide();
                    $cordovaDialogs.confirm(translate.multiLanguage('your_gps_is_turn_off_this_app_needs_to_be_enabled_to_works',lang_id),
                        translate.multiLanguage('please_turn_on_gps',lang_id), [translate.multiLanguage('cancel',lang_id),translate.multiLanguage('ok',lang_id)])
                        .then(function(buttonIndex) {
                            switch(buttonIndex) {
                                case 0: break;//cancel
                                case 1: break;//neutro option
                                case 2: cordova.plugins.diagnostic.switchToLocationSettings();
                                    break;//user go to configuration
                            }
                        });
                }

            });
        };

        $scope.stockist_name = $stateParams.stockistName;

        $scope.my_location = "";

        $scope.$on('mapInitialized', function(event, map) {
            $scope.map = map;
        });

        $scope.centerOnMe= function(){

            $scope.positions = [];

            $ionicLoading.show({
                template: 'Loading...'
            });

            // with this function you can get the user’s current position
            // we use this plugin: https://github.com/apache/cordova-plugin-geolocation/
            navigator.geolocation.getCurrentPosition(function(position) {
                var pos = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
                $scope.current_position = {lat: pos.G,lng: pos.K};
                $scope.my_location = pos.G+", "+pos.K;
                $scope.map.setCenter(pos);
                $ionicLoading.hide();
            });
        };


        //$scope.info_position = {
        //    lat: 3.026311,
        //    lng: 101.615095
        //};
        //
        //$scope.center_position = {
        //    lat: 3.026311,
        //    lng: 101.615095
        //};

        //$scope.my_location = "";
        //
        //$scope.$on('mapInitialized', function(event, map) {
        //    $scope.map = map;
        //});

        //$scope.centerOnMe= function(){
        //
        //    $scope.positions = [];
        //
        //    $ionicLoading.show({
        //        template: 'Loading...'
        //    });
        //
        //    // with this function you can get the user’s current position
        //    // we use this plugin: https://github.com/apache/cordova-plugin-geolocation/
        //    navigator.geolocation.getCurrentPosition(function(position) {
        //        var pos = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
        //        $scope.current_position = {lat: pos.G,lng: pos.K};
        //        $scope.my_location = pos.G+", "+pos.K;
        //        $scope.map.setCenter(pos);
        //        $ionicLoading.hide();
        //    });
        //};


    })
    .controller('nearbyCtrl', function($scope, $ionicConfig,$state,mapService,$cordovaGeolocation,$ionicLoading) {
        var data2 = JSON.parse(window.localStorage.getItem('connAPI'));
        console.log(data2);
        var comp_code = data2.mobile_user[0].company_code;
        var mem_id = data2.mobile_user[0].member_id;
        var conn_id = window.localStorage.getItem('connId');
        var lang_id = data2.mobile_user[0].lang_id;
        var company_code=data2.mobile_user[0].company_code;
        var member_id=data2.mobile_user[0].member_id;
        var lati='3.1278677';
        var longi='101.5956468';
        var radius='20';
        var record_count='5';
        var search='';
        //var conn_id='fOZikh7KsgI:APA91bEzOofavlv3G-D1d3Dd4iRXas5dWeaV5PIWR-w-8l7TxKdsN630GqwggjycBVLb7lkPBRFAqx2hc2sFkUGyRjutvi0DTiqyw9BXvk8mQYcqCJ3-Fh1mW0c3ECgMQCO9i3ppukHG';
        var conn_id=window.localStorage.getItem('connId');
        var lang_id='EN';

        $ionicLoading.show({ template: 'Loading Content...', noBackdrop: false});
        mapService.getListAPI(company_code,member_id,conn_id,lang_id,lati,longi,radius,record_count,search).then(function(data){
            console.log(data);
            $ionicLoading.hide();
            $scope.items = data.data;
        });


        //$scope.items = allData.data;
        var watchOptions = {
            timeout : 3000,
            enableHighAccuracy: false // may cause errors if true
        };

        var watch = $cordovaGeolocation.watchPosition(watchOptions);
        watch.then(
            null,
            function(err) {
                alert('GPS not enabled');
            },
            function(position) {
                var lat  = position.coords.latitude;
                var long = position.coords.longitude;
            });
    })
;